/*
** Q[OtBbNX_p⏕vO
**

Copyright (c) 2011 Kohe Tokoi. All Rights Reserved.

Permission is hereby granted, free of charge,  to any person obtaining a copy 
of this software and associated documentation files (the "Software"), to deal 
in the Software without restriction,  including without limitation the rights 
to use, copy,  modify, merge,  publish, distribute,  sublicense,  and/or sell 
copies or substantial portions of the Software.

The above  copyright notice  and this permission notice  shall be included in 
all copies or substantial portions of the Software.

THE SOFTWARE  IS PROVIDED "AS IS",  WITHOUT WARRANTY OF ANY KIND,  EXPRESS OR 
IMPLIED,  INCLUDING  BUT  NOT LIMITED  TO THE WARRANTIES  OF MERCHANTABILITY, 
FITNESS  FOR  A PARTICULAR PURPOSE  AND NONINFRINGEMENT.  IN  NO EVENT  SHALL 
KOHE TOKOI  BE LIABLE FOR ANY CLAIM,  DAMAGES OR OTHER LIABILITY,  WHETHER IN 
AN ACTION  OF CONTRACT,  TORT  OR  OTHERWISE,  ARISING  FROM,  OUT OF  OR  IN 
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

**
*/

#ifndef __GG_H__
#define __GG_H__

#include <cstring>
#include <cmath>

#if defined(WIN32)
#  pragma warning(disable:4996)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "wglew.h"
#  include "glut.h"
#elif defined(X11)
#  define GL_GLEXT_PROTOTYPES
#  define GLX_GLXEXT_PROTOTYPES
#  include <GL/gl.h>
#  include <GL/glu.h>
#  include <GL/glx.h>
#  include <GL/glut.h>
#elif defined(__APPLE__)
#  include <OpenGL/OpenGL.h>
#  include <GLUT/glut.h>
// GL_ARB_texture_float
#  define GL_RGBA32F GL_RGBA32F_ARB
#  define GL_RGB32F GL_RGB32F_ARB
#  define GL_ALPHA32F GL_ALPHA32F_ARB
#  define GL_INTENSITY32F GL_INTENSITY32F_ARB
#  define GL_LUMINANCE32F GL_LUMINANCE32F_ARB
#  define GL_LUMINANCE_ALPHA32F GL_LUMINANCE_ALPHA32F_ARB
#  define GL_RGBA16F GL_RGBA16F_ARB
#  define GL_RGB16F GL_RGB16F_ARB
#  define GL_ALPHA16F GL_ALPHA16F_ARB
#  define GL_INTENSITY16F GL_INTENSITY16F_ARB
#  define GL_LUMINANCE16F GL_LUMINANCE16F_ARB
#  define GL_LUMINANCE_ALPHA16F GL_LUMINANCE_ALPHA16F_ARB
// GL_EXT_transform_feedback
#  define glBindBufferRange glBindBufferRangeEXT
#  define glBindBufferOffset glBindBufferOffsetEXT
#  define glBindBufferBase glBindBufferBaseEXT
#  define glBeginTransformFeedback glBeginTransformFeedbackEXT
#  define glEndTransformFeedback glEndTransformFeedbackEXT
#  define glTransformFeedbackVaryings glTransformFeedbackVaryingsEXT
#  define glGetTransformFeedbackVarying glGetTransformFeedbackVaryingEXT
#  define glGetIntegerIndexedv glGetIntegerIndexedvEXT
#  define glGetBooleanIndexedv glGetBooleanIndexedvEXT
#  define GL_TRANSFORM_FEEDBACK_BUFFER GL_TRANSFORM_FEEDBACK_BUFFER_EXT
#  define GL_TRANSFORM_FEEDBACK_BUFFER_START GL_TRANSFORM_FEEDBACK_BUFFER_START_EXT
#  define GL_TRANSFORM_FEEDBACK_BUFFER_SIZE GL_TRANSFORM_FEEDBACK_BUFFER_SIZE_EXT
#  define GL_TRANSFORM_FEEDBACK_BUFFER_BINDING GL_TRANSFORM_FEEDBACK_BUFFER_BINDING_EXT
#  define GL_INTERLEAVED_ATTRIBS GL_INTERLEAVED_ATTRIBS_EXT
#  define GL_SEPARATE_ATTRIBS GL_SEPARATE_ATTRIBS_EXT
#  define GL_PRIMITIVES_GENERATED GL_PRIMITIVES_GENERATED_EXT
#  define GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN_EXT
#  define GL_RASTERIZER_DISCARD GL_RASTERIZER_DISCARD_EXT
#  define GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS_EXT
#  define GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS_EXT
#  define GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS_EXT
#  define GL_TRANSFORM_FEEDBACK_VARYINGS GL_TRANSFORM_FEEDBACK_VARYINGS_EXT
#  define GL_TRANSFORM_FEEDBACK_BUFFER_MODE GL_TRANSFORM_FEEDBACK_BUFFER_MODE_EXT
#  define GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH_EXT
// GL_APPLE_vertex_array_object
#  define glGenVertexArrays glGenVertexArraysAPPLE
#  define glBindVertexArray glBindVertexArrayAPPLE
#  define glDeleteVertexArrays glDeleteVertexArraysAPPLE
#  define glIsVertexArray glIsVertexArrayAPPLE
#  define GL_VERTEX_ARRAY_BINDING GL_VERTEX_ARRAY_BINDING_APPLE
#else
#  error "This platform is not supported."
#endif

#define GG_DEG_TO_RAD(a) ((a) * 0.017453293f)

namespace gg
{
  /*
  ** Q[OtBbNX_̓sɂƂÂ
  **
  **    OpenGL ̃_OReLXg쐬Ɏs
  */
  extern void ggInit(void);

  /*
  ** OpenGL ̃G[`FbN
  **
  **    OpenGL  API ĂяoɎs΃G[̂ƂɃbZ[W\
  **    msg ̓bZ[Wɏ悶镶
  */
  extern void ggError(const char *msg = 0);

  /*
  ** FBO ̃G[`FbN
  **
  **    FBO  API ĂяoɎs΃G[̂ƂɃbZ[W\
  **    msg ̓bZ[Wɏ悶镶
  */
  extern void ggFBOError(const char *msg = 0);

  /*
  ** ϊs
  */
  class GgMatrix
  {
    // ϊs̗vf
    GLfloat array[16];

    // s a ƃxNg b ̐ςxNg c ɑ
    void projection(GLfloat *c, const GLfloat *a, const GLfloat *b) const;

    // s a ƍs b ̐ςs c ɑ
    void multiply(GLfloat *c, const GLfloat *a, const GLfloat *b) const;

  public:

    // fXgN^
    virtual ~GgMatrix(void) {}

    // RXgN^
    GgMatrix(void) {}
    GgMatrix(const GLfloat *a)
    {
      load(a);
    }
    GgMatrix(const GgMatrix &m)
    {
      load(m);
    }

    // Zq
    GgMatrix &multiply(const GgMatrix &m, const GgMatrix &n)
    {
      multiply(array, m.array, n.array);
      return *this;
    }
    GgMatrix &multiply(const GgMatrix &m, const GLfloat *a)
    {
      multiply(array, m.array, a);
      return *this;
    }
    GgMatrix &multiply(const GLfloat *a)
    {
      GLfloat t[16]; multiply(t, array, a);
      memcpy(array, t, sizeof array); return *this;
    }
    GgMatrix &multiply(const GgMatrix &m)
    {
      return multiply(m.array);
    }
    GgMatrix &operator=(const GLfloat *a)
    {
      return load(a);
    }
    GgMatrix &operator=(const GgMatrix &m)
    {
      return load(m);
    }
    GgMatrix operator*(const GLfloat *a) const
    {
      GgMatrix t;
      t.multiply(t.array, this->array, a);
      return t;
    }
    GgMatrix operator*(const GgMatrix &m) const
    {
      GgMatrix t;
      t.multiply(t.array, this->array, m.array);
      return t;
    }
    GgMatrix &operator*=(const GLfloat *a)
    {
      return multiply(a);
    }
    GgMatrix &operator*=(const GgMatrix &m)
    {
      return multiply(m);
    }

    // ϊs̓ǂݍ
    GgMatrix &load(const GLfloat *a)
    {
      memcpy(array, a, sizeof array);
      return *this;
    }
    GgMatrix &load(const GgMatrix &m)
    {
      return load(m.array);
    }

    // Pʍsݒ肷
    GgMatrix &loadIdentity(void);

    // sړ̕ϊsݒ肷
    GgMatrix &loadTranslate(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f);
    GgMatrix &loadTranslate(const GLfloat *t)
    {
      return loadTranslate(t[0], t[1], t[2], t[3]);
    }

    // gk̕ϊsݒ肷
    GgMatrix &loadScale(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f);
    GgMatrix &loadScale(const GLfloat *s)
    {
      return loadScale(s[0], s[1], s[2], s[3]);
    }

    // ]̕ϊsݒ肷
    GgMatrix &loadRotateX(GLfloat a);
    GgMatrix &loadRotateY(GLfloat a);
    GgMatrix &loadRotateZ(GLfloat a);
    GgMatrix &loadRotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a);
    GgMatrix &loadRotate(const GLfloat *r)
    {
      return loadRotate(r[0], r[1], r[2], r[3]);
    }

    // ϊsݒ肷
    GgMatrix &loadLookat(GLfloat ex, GLfloat ey, GLfloat ez, GLfloat tx, GLfloat ty, GLfloat tz, GLfloat ux, GLfloat uy, GLfloat uz);
    GgMatrix &loadLookat(const GLfloat *e, const GLfloat *t, const GLfloat *u)
    {
      return loadLookat(e[0], e[1], e[2], t[0], t[1], t[2], u[0], u[1], u[2]);
    }

    // 𓊉eϊsݒ肷
    GgMatrix &loadOrthogonal(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // eϊsݒ肷
    GgMatrix &loadFrustum(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // pw肵ēeϊsݒ肷
    GgMatrix &loadPerspective(GLfloat fovy, GLfloat aspect, GLfloat zNear, GLfloat zFar);

    // ]usݒ肷
    GgMatrix &loadTranspose(const GgMatrix &m);

    // tsݒ肷
    GgMatrix &loadInvert(const GgMatrix &m);

    // @ϊsݒ肷
    GgMatrix &loadNormal(const GgMatrix &m);

    // sړϊ悶
    GgMatrix &translate(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f)
    {
      GgMatrix m; m.loadTranslate(x, y, z, w); multiply(m);
      return *this;
    }
    GgMatrix &translate(const GLfloat *t)
    {
      return translate(t[0], t[1], t[2], t[3]);
    }

    // gkϊ悶
    GgMatrix &scale(GLfloat x, GLfloat y, GLfloat z, GLfloat w = 1.0f)
    {
      GgMatrix m;
      m.loadScale(x, y, z, w);
      multiply(m);
      return *this;
    }
    GgMatrix &scale(const GLfloat *s)
    {
      return scale(s[0], s[1], s[2], s[3]);
    }

    // ]ϊ悶
    GgMatrix &rotateX(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateX(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotateY(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateY(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotateZ(GLfloat a)
    {
      GgMatrix m;
      m.loadRotateZ(a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a)
    {
      GgMatrix m;
      m.loadRotate(x, y, z, a);
      multiply(m);
      return *this;
    }
    GgMatrix &rotate(const GLfloat *r)
    {
      return rotate(r[0], r[1], r[2], r[3]);
    }

    // ϊ悶
    GgMatrix &lookat(GLfloat ex, GLfloat ey, GLfloat ez, GLfloat tx, GLfloat ty, GLfloat tz, GLfloat ux, GLfloat uy, GLfloat uz);
    GgMatrix &lookat(const GLfloat *e, const GLfloat *t, const GLfloat *u)
    {
      return lookat(e[0], e[1], e[2], t[0], t[1], t[2], u[0], u[1], u[2]);
    }

    // 𓊉eϊ悶
    GgMatrix &orthogonal(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // eϊ悶
    GgMatrix &frustum(GLfloat left, GLfloat right, GLfloat bottom, GLfloat top, GLfloat zNear, GLfloat zFar);

    // pw肵ēeϊ悶
    GgMatrix &perspective(GLfloat fovy, GLfloat aspect, GLfloat zNear, GLfloat zFar);

    // ]us𓾂
    GgMatrix transpose(void) const
    {
      GgMatrix t;
      return t.loadTranspose(*this);
    }

    // ts𓾂
    GgMatrix invert(void) const
    {
      GgMatrix t;
      return t.loadInvert(*this);
    }

    // @ϊs𓾂
    GgMatrix normal(void) const
    {
      GgMatrix t;
      return t.loadNormal(*this);
    }

    // xNgɑ΂ēeϊs
    void projection(GLfloat *c, const GLfloat *v) const
    {
      projection(c, array, v);
    }

    // ϊs𓾂
    const GLfloat *get(void) const
    {
      return array;
    }
  };

  /*
  ** l
  */
  class GgQuaternion
  {
    // l̗vf
    GLfloat array[4];

    // l p Ǝl q ̘al r ɋ߂
    void add(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l p Ǝl q ̍l r ɋ߂
    void subtract(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l p Ǝl q ̐ςl r ɋ߂
    void multiply(GLfloat *r, const GLfloat *p, const GLfloat *q) const;

    // l q \]̕ϊs m ɋ߂
    void toMatrix(GLfloat *m, const GLfloat *q) const;

    // ]̕ϊs m \l q ɋ߂
    void toQuaternion(GLfloat *q, const GLfloat *m) const;

    // ʐ` q  r  t ŕԂl p ɋ߂
    void slerp(GLfloat *p, const GLfloat *q, const GLfloat *r, GLfloat t) const;

  public:

    // fXgN^
    virtual ~GgQuaternion(void) {}

    // RXgN^
    GgQuaternion(void) {}
    GgQuaternion(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
    {
      load(x, y, z, w);
    }
    GgQuaternion(const GLfloat *a)
    {
      load(a);
    }
    GgQuaternion(const GgQuaternion &q)
    {
      load(q);
    }

    // Zq
    GgQuaternion &operator=(const GLfloat *a)
    {
      return load(a);
    }
    GgQuaternion &operator=(const GgQuaternion &q)
    {
      return load(q);
    }
    GgQuaternion operator+(const GLfloat *a) const
    {
      GgQuaternion t;
      t.add(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator+(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.add(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator+=(const GLfloat *a)
    {
      return add(a);
    }
    GgQuaternion &operator+=(const GgQuaternion &q)
    {
      return add(q);
    }
    GgQuaternion operator-(const GLfloat *a) const
    {
      GgQuaternion t;
      t.subtract(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator-(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.subtract(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator-=(const GLfloat *a)
    {
      return subtract(a);
    }
    GgQuaternion &operator-=(const GgQuaternion &q)
    {
      return subtract(q);
    }
    GgQuaternion operator*(const GLfloat *a) const
    {
      GgQuaternion t;
      t.multiply(t.array, this->array, a);
      return t;
    }
    GgQuaternion operator*(const GgQuaternion &q) const
    {
      GgQuaternion t;
      t.multiply(t.array, this->array, q.array);
      return t;
    }
    GgQuaternion &operator*=(const GLfloat *a)
    {
      return multiply(a);
    }
    GgQuaternion &operator*=(const GgQuaternion &q)
    {
      return multiply(q);
    }

    // lݒ肷
    GgQuaternion &load(GLfloat x, GLfloat y, GLfloat z, GLfloat w)
    {
      array[0] = x;
      array[1] = y;
      array[2] = z;
      array[3] = w;
      return *this;
    }
    GgQuaternion &load(const GLfloat *a)
    {
      return load(a[0], a[1], a[2], a[3]);
    }
    GgQuaternion &load(const GgQuaternion &q)
    {
      return load(q.array);
    }

    // ]̕ϊs m \lݒ肷
    GgQuaternion &loadMatrix(const GLfloat *m)
    {
      toQuaternion(array, m); return *this;
    }

    // Pʌݒ肷
    GgQuaternion &loadIdentity(void)
    {
      return load(0.0f, 0.0f, 0.0f, 1.0f);
    }

    // (x, y, z) ƂĊpx a ]鎑ݒ肷
    GgQuaternion &loadRotate(GLfloat x, GLfloat y, GLfloat z, GLfloat a);
    GgQuaternion &loadRotate(const GLfloat *v, GLfloat a)
    {
      return loadRotate(v[0], v[1], v[2], a);
    }

    // IC[p (h, p, r) ŗ^ꂽ]\lݒ肷
    GgQuaternion &loadEuler(GLfloat h, GLfloat p, GLfloat r);
    GgQuaternion &loadEuler(const GLfloat *e)
    {
      return loadEuler(e[0], e[1], e[2]);
    }

    // l̘a߂
    GgQuaternion &add(const GgQuaternion &p, const GgQuaternion &q)
    {
      add(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &add(const GgQuaternion &q, const GLfloat *a)
    {
      add(array, q.array, a);
      return *this;
    }
    GgQuaternion &add(const GLfloat *a)
    {
      GLfloat t[4];
      add(t, array, a);
      return load(t);
    }
    GgQuaternion &add(const GgQuaternion &q)
    {
      return add(q.array);
    }

    // l̍߂
    GgQuaternion &subtract(const GgQuaternion &p, const GgQuaternion &q)
    {
      subtract(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &subtract(const GgQuaternion &q, const GLfloat *a)
    {
      subtract(array, q.array, a);
      return *this;
    }
    GgQuaternion &subtract(const GLfloat *a)
    {
      GLfloat t[4];
      subtract(t, array, a);
      return load(t);
    }
    GgQuaternion &subtract(const GgQuaternion &q)
    {
      return subtract(q.array);
    }

    // l̐ς߂
    GgQuaternion &multiply(const GgQuaternion &p, const GgQuaternion &q)
    {
      multiply(array, p.array, q.array);
      return *this;
    }
    GgQuaternion &multiply(const GgQuaternion &q, const GLfloat *a)
    {
      multiply(array, q.array, a);
      return *this;
    }
    GgQuaternion &multiply(const GLfloat *a)
    {
      GLfloat t[4]; multiply(t, array, a);
      return load(t);
    }
    GgQuaternion &multiply(const GgQuaternion &q)
    {
      return multiply(q.array);
    }

    // ʐ`
    GgQuaternion &slerp(const GgQuaternion &q, const GgQuaternion &r, GLfloat t)
    {
      slerp(array, q.array, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(const GgQuaternion &q, const GLfloat *b, GLfloat t)
    {
      slerp(array, q.array, b, t);
      return *this;
    }
    GgQuaternion &slerp(const GLfloat *a, const GgQuaternion &r, GLfloat t)
    {
      slerp(array, a, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(const GLfloat *a, const GLfloat *b, GLfloat t)
    {
      slerp(array, a, b, t);
      return *this;
    }
    GgQuaternion &slerp(const GgQuaternion &r, GLfloat t)
    {
      slerp(array, array, r.array, t);
      return *this;
    }
    GgQuaternion &slerp(GLfloat *b, GLfloat t)
    {
      slerp(array, array, b, t);
      return *this;
    }

    // l̃m߂
    GLfloat norm(void) const;

    // l߂
    GgQuaternion conjugate(void) const;

    // l̋t߂
    GgQuaternion invert(void) const;

    // l𐳋K
    GgQuaternion normalize(void) const;

    // l߂
    const GLfloat *get(void) const
    {
      return array;
    }
    void get(GLfloat *a) const
    {
      a[0] = array[0];
      a[1] = array[1];
      a[2] = array[2];
      a[3] = array[3];
    }

    // l\]̍s m ɋ߂
    void getMatrix(GLfloat *m) const
    {
      toMatrix(m, array);
    }
  };

  /*
  ** eNX`
  **
  **    gUːFeNX`ǂݍŃeNX`IuWFNg쐬
  */
  class GgTexture
  {
    // eNX`
    GLuint texture;

  public:

    // fXgN^
    virtual ~GgTexture(void)
    {
      glDeleteTextures(1, &texture);
    }

    // RXgN^
    GgTexture(void)
    {
      glGenTextures(1, &texture);
    }

    // RXgN^
    GgTexture(
      const char *filename,               // 摜t@Ci3/4 `l RAW 摜j
      int width, int height,              // 摜̕ƍi2^n fj
      GLenum format = GL_RGB              // ǂݍމ摜̏ (GL_RGB/GL_RGBA)
      )
    {
      glGenTextures(1, &texture);
      load(filename, width, height, format);
    }

    // Rs[RXgN^
    GgTexture(const GgTexture &o)
      : texture(o.texture) {}

    // Zq
    GgTexture &operator=(const GgTexture &o)
    {
      if (this != &o)
      {
        glDeleteTextures(1, &texture);
        texture = o.texture;
      }

      return *this;
    }

    // gUːFeNX`ǂݍ
    //    filename: t@C, width, height: ƍ (2^n), format: GL_RGB  GL_RGBA
    void load(const char *filename, int width, int height, GLenum format = GL_RGB) const;

    // eNX`IuWFNggp
    void bind(void) const
    {
      glBindTexture(GL_TEXTURE_2D, texture);
    }
    
    // eNX`IuWFNg擾
    GLuint tex(void) const
    {
      return texture;
    }
  };

  /*
  ** @}bv
  **
  **    }bviOCXP[摜jǂݍŖ@}bv쐬
  */
  class GgNormalTexture
    : public GgTexture
  {
  public:

    // fXgN^
    virtual ~GgNormalTexture(void) {}

    // RXgN^
    GgNormalTexture(void) {}

    // RXgN^
    GgNormalTexture(
      const char *filename,               // 摜t@Ci1 `l RAW 摜j
      int width, int height,              // 摜̕ƍi2^n fj
      float nz = 1.0f                     // @}bv z ̒l
      ) : GgTexture()                     // eNX`IuWFNg쐬
    {
      load(filename, width, height, nz);
    }

    // Rs[RXgN^
    GgNormalTexture(const GgNormalTexture &o)
      : GgTexture(o) {}

    // Zq
    GgNormalTexture &operator=(const GgNormalTexture &o)
    {
      if (this != &o)
      {
        GgTexture::operator=(o);
      }

      return *this;
    }

    // }bvǂݍŖ@}bv쐬
    //    filename: t@C, width, height: ƍ (2^n), nz: @}bv z ̒l
    void load(const char *filename, int width, int height, float nz = 1.0f) const;
  };

  /*
  ** VF[_
  **
  **    VF[_̊NX
  */
  class GgShader
  {
    // vO
    GLuint program;

    // VF[_̃\[XvOǂݍ
    bool readShaderSource(GLuint shader, const char *filename) const;

    // VF[_̃\[XvÕRpC\
    void printShaderInfoLog(GLuint shader) const;

    // VF[_̃IuWFNgvÕN\
    void printProgramInfoLog(GLuint program) const;

  public:

    // fXgN^
    virtual ~GgShader(void)
    {
      glDeleteProgram(program);
    }

    // RXgN^
    GgShader(void)
      : program(glCreateProgram()) {}

    // RXgN^
    GgShader(
      const char *vert,                   // o[ebNXVF[_̃\[Xt@C
      const char *frag = 0,               // tOgVF[_̃\[Xt@Ci0 Ȃsgpj
      const char *geom = 0,               // WIgVF[_̃\[Xt@Ci0 Ȃsgpj
      GLenum input = GL_TRIANGLES,        // WIgVF[_̓̓v~eBu
      GLenum output = GL_TRIANGLE_STRIP,  // WIgVF[_̏o̓v~eBu
      int nvarying = 0,                   // tB[hobN varying ϐ̐i0 Ȃsgpj
      const char **varyings = 0           // tB[hobN varying ϐ̃Xg
      )
      : program(glCreateProgram())
    {
      load(vert, frag, geom, input, output, nvarying, varyings);
    }

    // Rs[RXgN^
    GgShader(const GgShader &o)
      : program(o.program) {}

    // Zq
    GgShader &operator=(const GgShader &o)
    {
      if (this != &o)
      {
        glDeleteProgram(program);
        program = o.program;
      }

      return *this;
    }

    // VF[_̃\[XvOǂݍŃRpCENăvOIuWFNg쐬
    bool load(const char *vert, const char *frag = 0, const char *geom = 0,
      GLenum input = GL_TRIANGLES, GLenum output = GL_TRIANGLE_STRIP,
      int nvarying = 0, const char **varyings = 0) const;

    // vOIuWFNggp
    void use(void) const
    {
      glUseProgram(program);
    }
    
    // vOIuWFNg擾
    GLuint getProgram(void) const
    {
      return program;
    }
  };

  /*
  ** obt@IuWFNg
  **
  **    _^CfbNXobt@IuWFNg̊NX
  */
  template <typename T> class GgBuffer
  {
    // obt@IuWFNg
    GLuint buffer;

    // f[^
    unsigned int number;

  public:

    // fXgN^
    virtual ~GgBuffer<T>(void)
    {
      glDeleteBuffers(1, &buffer);
    }

    // RXgN^
    GgBuffer<T>(void)
      : number(0)
    {
      glGenBuffers(1, &buffer);
    }

    // RXgN^
    GgBuffer<T>(GLenum target, unsigned int n, const T *data, GLenum usage = GL_STATIC_DRAW)
    {
      glGenBuffers(1, &buffer);
      load(target, n, data, usage);
    }

    // Rs[RXgN^
    GgBuffer<T>(const GgBuffer<T> &o)
    {
      buffer = o.buffer;
      number = o.number;
    }

    // Zq
    GgBuffer<T> &operator=(const GgBuffer<T> &o)
    {
      if (this != &o)
      {
        glDeleteBuffers(1, &buffer);
        buffer = o.buffer;
        number = o.number;
      }

      return *this;
    }

    // f[^̎擾
    void load(GLenum target, unsigned int n, const T *data, GLenum usage = GL_STATIC_DRAW)
    {
      number = n;
      glBindBuffer(target, buffer);
      glBufferData(target, sizeof (T) * n, data, usage);
    }

    // obt@IuWFNg𓾂
    GLuint buf(void) const
    {
      return buffer;
    }

    // f[^̐𓾂
    unsigned int num(void) const
    {
      return number;
    }
  };

  /*
  ** _Q
  **
  **    _obt@IuWFNggp`f[^̂߂̊NX
  */
  class GgPoints
  {
    // _obt@IuWFNg
    GgBuffer<GLfloat[3]> position;
    
  protected:

    // obt@IuWFNg𓾂
    GLuint pbuf(void) const
    {
      return position.buf();
    }

    // f[^̐𓾂
    unsigned int pnum(void) const
    {
      return position.num();
    }

  public:
    
    // fXgN^
    virtual ~GgPoints(void) {}
    
    // RXgN^
    GgPoints(void) {}
    
    // RXgN^
    //    n: _, pos: _̈ʒu
    GgPoints(int n, const GLfloat (*pos)[3], GLenum usage = GL_STATIC_DRAW)
    {
      load(n, pos, usage);
    }

    // Rs[RXgN^
    GgPoints(const GgPoints &o)
      : position(o.position) {}

    // Zq
    GgPoints &operator=(const GgPoints &o)
    {
      if (this != &o)
      {
        position = o.position;
      }

      return *this;
    }
    
    // obt@IuWFNgmۂĒ_i[
    //    n: _, pos: _̈ʒu
    void load(int n, const GLfloat (*pos)[3], GLenum usage = GL_STATIC_DRAW)
    {
      position.load(GL_ARRAY_BUFFER, n, pos, usage);
    }

    // _Q`悷葱
    virtual void draw(GLint pvLoc, GLenum mode = GL_POINTS);
  };
  
  /*
  ** Op`Q
  **
  **    _݂̂ŕ\ꂽ}`̂߂̊NX
  */
  class GgTriangles
    : public GgPoints
  {
    // @̒_obt@IuWFNg
    GgBuffer<GLfloat[3]> normal;

    // _̏ꏊ
    GLint location;

  protected:

    // obt@IuWFNg𓾂
    GLuint nbuf(void) const
    {
      return normal.buf();
    }

    // f[^̐𓾂
    unsigned int nnum(void) const
    {
      return normal.num();
    }

  public:

    // fXgN^
    virtual ~GgTriangles(void) {}

    // RXgN^
    GgTriangles(void) {}

    // RXgN^
    //    n: _, pos: _̈ʒu, norm: _̖@
    GgTriangles(int n, const GLfloat (*pos)[3], const GLfloat (*norm)[3], GLenum usage = GL_STATIC_DRAW)
      : GgPoints(n, pos, usage)
    {
      normal.load(GL_ARRAY_BUFFER, n, norm, usage);
    }

    // Rs[RXgN^
    GgTriangles(const GgTriangles &o)
      : GgPoints(o), normal(o.normal) {}

    // Zq
    GgTriangles &operator=(const GgTriangles &o)
    {
      if (this != &o)
      {
        GgPoints::operator=(o);
        normal = o.normal;
      }

      return *this;
    }
    
    // obt@IuWFNgmۂĈʒuƖ@i[
    //    n: _, pos: _̈ʒu, norm: _̖@
    void load(int n, const GLfloat (*pos)[3], const GLfloat (*norm)[3], GLenum usage = GL_STATIC_DRAW)
    {
      GgPoints::load(n, pos, usage);
      normal.load(GL_ARRAY_BUFFER, n, norm, usage);
    }

    // Op`Q`悷葱
    virtual void draw(GLint pvLoc, GLint nvLoc, GLenum mode = GL_TRIANGLES);
  };

  /*
  ** `
  **
  **    xy ʏ̋`̌`f[^
  */
  class GgRectangle
    : public GgTriangles
  {
  public:
    
    // fXgN^
    virtual ~GgRectangle(void) {}
    
    // RXgN^
    GgRectangle(GLfloat w = 2.0f, GLfloat h = 2.0f)
    {
      resize(w, h);
    }
    
    // Rs[RXgN^
    GgRectangle(const GgRectangle &o)
      : GgTriangles(o) {}
    
    // Zq
    GgRectangle &operator=(const GgRectangle &o)
    {
      if (this != &o)
      {
        GgTriangles::operator=(o);
      }

      return *this;
    }
    
    // `̃TCYύX
    //    w, h: `̕ƍ
    void resize(GLfloat w, GLfloat h);

    // Op`Q`悷葱
    virtual void draw(GLint pvLoc, GLint nvLoc, GLenum mode = GL_TRIANGLE_FAN)
    {
      GgTriangles::draw(pvLoc, nvLoc, mode);
    }
  };

  /*
  ** ȉ~`
  **
  **    Op`̌`f[^ŕ\ xy ʏ̑ȉ~`
  */
  class GgEllipse
    : public GgTriangles
  {
  public:

    // fXgN^
    virtual ~GgEllipse(void) {}

    // RXgN^
    GgEllipse(GLfloat w = 2.0f, GLfloat h = 2.0f, int slices = 16)
    {
      resize(w, h, slices);
    }

    // Rs[RXgN^
    GgEllipse(const GgEllipse &o)
      : GgTriangles(o) {}

    // Zq
    GgEllipse &operator=(const GgEllipse &o)
    {
      if (this != &o)
      {
        GgTriangles::operator=(o);
      }

      return *this;
    }

    // ȉ~`̃TCYƕύX
    //    w: ȉ~`̕, h: ȉ~`̍, slices: ӂ̐ij
    void resize(GLfloat w, GLfloat h, int slices = 16);

    // Op`Q`悷葱
    virtual void draw(GLint pvLoc, GLint nvLoc, GLenum mode = GL_TRIANGLE_FAN)
    {
      GgTriangles::draw(pvLoc, nvLoc, mode);
    }
  };

  /*
  ** Op`bV
  **
  **    _CfbNXgp}`̂߂̊NX
  */
  class GgMesh
    : public GgTriangles
  {
    // CfbNXobt@IuWFNg
    GgBuffer<GLuint[3]> index;

  protected:

    // obt@IuWFNg𓾂
    GLuint fbuf(void) const
    {
      return index.buf();
    }

    // f[^̐𓾂
    unsigned int fnum(void) const
    {
      return index.num();
    }

  public:

    // fXgN^
    virtual ~GgMesh(void) {}

    // RXgN^
    GgMesh(void) {}

    // RXgN^
    //    n: _, pos: _̈ʒu, norm:_̖@
    //    f: ʐ, face: _̃CfbNXf[^
    GgMesh(int n, int f, const GLfloat (*pos)[3], const GLfloat (*norm)[3],
      const GLuint (*face)[3], GLenum usage = GL_STATIC_DRAW)
      : GgTriangles(n, pos, norm, usage)
    {
      index.load(GL_ELEMENT_ARRAY_BUFFER, f, face);
    }

    // Rs[RXgN^
    GgMesh(const GgMesh &o)
      : GgTriangles(o), index(o.index) {}

    // Zq
    GgMesh &operator=(const GgMesh &o)
    {
      if (this != &o)
      {
        GgTriangles::operator=(o);
        index = o.index;
      }

      return *this;
    }

    // obt@IuWFNgmۂĈʒuƖ@ƃCfbNXi[
    //    n: _, pos: _̈ʒu, norm:_̖@
    //    f: ʐ, face: _̃CfbNXf[^
    void load(int n, int f, const GLfloat (*pos)[3], const GLfloat (*norm)[3],
      const GLuint (*face)[3], GLenum usage = GL_STATIC_DRAW)
    {
      GgTriangles::load(n, pos, norm, usage);
      index.load(GL_ELEMENT_ARRAY_BUFFER, f, face);
    }

    // Op`bV`悷葱
    virtual void draw(GLint pvLoc, GLint nvLoc, GLenum mode = GL_TRIANGLES);
  };

  /*
  ** 
  **
  **    Op`̌`f[^ŕ\_ɂ鋅
  */
  class GgSphere
    : public GgMesh
  {
  public:

    // fXgN^
    virtual ~GgSphere(void) {}

    // RXgN^
    //    TCYw肵ċ̃CX^X쐬
    //    diameter: a, slices: ox̕, stacks: ܓx̕
    GgSphere(GLfloat diameter = 1.0f, int slices = 16, int stacks = 8)
    {
      resize(diameter, slices, stacks);
    }

    // Rs[RXgN^
    GgSphere(const GgSphere &o)
      : GgMesh(o) {}
    
    // Zq
    GgSphere &operator=(const GgSphere &o)
    {
      if (this != &o)
      {
        GgMesh::operator=(o);
      }
      
      return *this;
    }

    // ̃TCYƕύX
    //    diameter: a, slices: ox̕, stacks: ܓx̕
    void resize(GLfloat diameter = 1.0f, int slices = 16, int stacks = 8);
  };
  
  /*
  ** Op`ꂽ Alias OBJ `̃f[^
  **
  **    Op`ꂽ Alias OBJ `̃f[^ɂOp`̌`f[^
  */
  class GgObj
    : public GgMesh
  {
  public:

    // fXgN^
    virtual ~GgObj(void) {}

    // RXgN^
    GgObj(void) {}

    // RXgN^
    //    Alias OBJ `̃t@CǂݍŃCX^X쐬
    //    filename: t@C, scale: 0 łȂΒS_ɂĊȇ傫̍ől scale ɂ
    GgObj(const char *filename, GLfloat scale = 0.0f)
    {
      loadfile(filename, scale);
    }

     // Rs[RXgN^
    GgObj(const GgObj &o)
      : GgMesh(o) {}

    // Zq
    GgObj &operator=(const GgObj &o)
    {
      if (this != &o)
      {
        GgMesh::operator=(o);
      }
      
      return *this;
    }
    
    // Alias OBJ `̃t@Cǂݍ
    //    filename: t@C, scale: 0 łȂΒS_ɂĊȇ傫̍ől scale ɂ
    bool loadfile(const char *filename, GLfloat scale = 0.0f);
  };

  /*
  ** ȈՃgbN{[
  */
  class GgTrackball
  {
    int cx, cy;       // hbOJnʒu
    bool drag;        // hbOۂ
    float sx, sy;     // }EX̐ΈʒuEBhEł̑ΈʒůZW
    GgQuaternion cq;  // ]̏l (l)
    GgQuaternion tq;  // hbỎ] (l)
    GLfloat rt[16];   // ]̕ϊs

  public:

    // fXgN^
    ~GgTrackball(void) {}

    // RXgN^
    GgTrackball(void);

    // gbN{[͈͎̔w
    //    EBhẼTCYɌĂяo
    void region(int w, int h);

    // gbN{[̊Jn
    //    }EX̃hbOJni}EX{^ƂjɌĂяo
    void start(int x, int y);

    // ]̕ϊšvZ
    //    }EX̃hbOɌĂяo
    void motion(int x, int y);

    // gbN{[̒~
    //    }EX̃hbOIi}EX{^𗣂ƂjɌĂяo
    void stop(int x, int y);

    // ݂̉]̕ϊs𓾂
    const GLfloat *get(void) const
    {
      return rt;
    }
  };
}

#endif
